## gammaray 2.0.1

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the GammaRay project.
#
# To build the man page from POD, run 'make man' after CMake (assumes perl is available)
# To install the resulting man page, run 'make install'
# Not available on Windows.
#
# To build the apidox, run 'make docs' after CMake (assumes doxygen is available)
#

project(GammaRay)

if(WIN32)
  # needed for automoc and QtMain to work correctly
  cmake_minimum_required(VERSION 2.8.11)
  cmake_policy(SET CMP0020 NEW)
else()
  cmake_minimum_required(VERSION 2.8.9)
endif()

if(NOT Prog_NAME)
  set(Prog_NAME "GammaRay")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(POLICY CMP0022)
  cmake_policy(SET CMP0022 OLD) # until we require 2.8.12
endif()

set(GAMMARAY_VERSION_MAJOR "2")
set(GAMMARAY_VERSION_MINOR "0")
set(GAMMARAY_VERSION_PATCH "1")
set(GAMMARAY_VERSION "${GAMMARAY_VERSION_MAJOR}.${GAMMARAY_VERSION_MINOR}.${GAMMARAY_VERSION_PATCH}")
set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION}")
set(GAMMARAY_SOVERSION "${GAMMARAY_VERSION}")
set(GAMMARAY_PLUGIN_VERSION "2.0")

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

enable_testing()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  if(GIT_FOUND)
    execute_process(
      COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE _git_revision
    )
    string(REGEX REPLACE "\n" "" _git_revision "${_git_revision}")
    set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION_STRING} (revision: ${_git_revision})")
  endif()
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif()

message(STATUS "Building ${Prog_NAME} ${GAMMARAY_VERSION_STRING} in ${CMAKE_BUILD_TYPE} mode")
add_definitions(-DPROGRAM_NAME=\"${Prog_NAME}\")
add_definitions(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)

include(CheckCXXCompilerFlag)
include(CheckLibraryExists)
include(GammaRayMacros)
include(GammaRayMacrosInternal)
include(MacroLogFeature)

set(QT_MIN_VERSION "4.7.0")

option(
  GAMMARAY_ENFORCE_QT4_BUILD
  "Enable if you want to enfore a build with Qt4"
  OFF
)

option(
  GAMMARAY_PROBE_ONLY_BUILD
  "Build only the probe, not the host tools (client, launcher, etc)."
  OFF
)

# try Qt5 first, and prefer that (if found), but only if not disabled via option
if(NOT GAMMARAY_ENFORCE_QT4_BUILD)
  find_package(Qt5Core QUIET)
endif()

if(Qt5Core_FOUND)
  # Qt5 COMPONENT x y z only works with Qt >= 5.1 ...
  find_package(Qt5Gui NO_MODULE REQUIRED)
  find_package(Qt5Network NO_MODULE REQUIRED)
  find_package(Qt5Concurrent NO_MODULE QUIET)
  find_package(Qt5Test NO_MODULE QUIET)
  find_package(Qt5Widgets NO_MODULE QUIET)
  find_package(Qt5PrintSupport NO_MODULE QUIET)
  find_package(Qt5Svg NO_MODULE QUIET)
  find_package(Qt5Script NO_MODULE QUIET)
  find_package(Qt5ScriptTools NO_MODULE QUIET)
  find_package(Qt5Location NO_MODULE QUIET) # workaround for 5.1 webkit that tries to find a qtlocation with a matching version if none (with any version) has been found before...
  find_package(Qt5Designer NO_MODULE QUIET)
  find_package(Qt5WebKitWidgets 5.0.2 NO_MODULE QUIET) # 5.0.[01] has a code generation bug in uic that fails to generate proper code for webkitwidget classes

  include("cmake/ECMQt4To5Porting.cmake")
  # only needed for Qt <= 5.1 and/or some older CMake versions (exact combination unknown unfortunately)
  include_directories(${QT_INCLUDES})

  set(HAVE_QT_CONCURRENT ${Qt5Concurrent_FOUND})
  set(HAVE_QT_WIDGETS ${Qt5Widgets_FOUND})
  set(HAVE_QT_SVG ${Qt5Svg_FOUND})
  set(HAVE_QT_DESIGNER ${Qt5Designer_FOUND})
  set(HAVE_QT_PRINTSUPPORT ${Qt5PrintSupport_FOUND})
  set(HAVE_QT_WEBKIT1 ${Qt5WebKitWidgets_FOUND})

  if(Qt5_POSITION_INDEPENDENT_CODE AND NOT WIN32)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  endif()

# Qt4
else()
  set(QT_USE_IMPORTED_TARGETS true)
  find_package(Qt4 ${QT_MIN_VERSION} REQUIRED QtCore QtGui QtNetwork)
  find_package(Qt4 ${QT_MIN_VERSION} QUIET COMPONENTS QtScript QtScriptTools QtWebKit QtDesigner QtSvg QtTest)

  include(${QT_USE_FILE})
  set(HAVE_QT_CONCURRENT true)
  set(HAVE_QT_WIDGETS true)
  set(HAVE_QT_SVG true)
  if(QT_QTDESIGNER_FOUND)
    set(HAVE_QT_DESIGNER true)
  endif()
  set(HAVE_QT_PRINTSUPPORT true)
  set(HAVE_QT_WEBKIT1 ${QT_QTWEBKIT_FOUND})
endif()

# TODO: Remove me once fixed in ECM module
if(Qt5Core_FOUND)
  # more hacks: find qpa/... includes
  # also see https://codereview.qt-project.org/#change,30483
  include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

  # TODO warnings rather than build errors for the deprecated methods would be nice...
  add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0)
endif()

# disable QT_STRICT_ITERATORS on the Qt5+Windows combo
# see: https://bugreports.qt-project.org/browse/QTBUG-29608
if(NOT (Qt5Core_FOUND AND WIN32))
  add_definitions(-DQT_STRICT_ITERATORS)
endif()

if(CMAKE_BUILD_TYPE MATCHES "^[Rr]elease$")
  add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif()

set(BIN_INSTALL_DIR "bin")
set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(LIB_INSTALL_DIR "lib${LIB_SUFFIX}")
set(INCLUDE_INSTALL_DIR "include/gammaray")
set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/GammaRay)
if(WIN32)
  set(PLUGIN_INSTALL_DIR "plugins")
  set(LIBEXEC_INSTALL_DIR "${BIN_INSTALL_DIR}")
else()
  set(PLUGIN_INSTALL_DIR "${LIB_INSTALL_DIR}/gammaray")
  set(LIBEXEC_INSTALL_DIR "${LIB_INSTALL_DIR}/gammaray/libexec")
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR})

# set RPATH only when installing to a non-default location
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
list(FIND CMAKE_C_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" _isSystemCLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
if(${_isSystemPlatformLibDir} EQUAL -1 AND ${_isSystemCLibDir} EQUAL -1 AND ${_isSystemCxxLibDir} EQUAL -1)
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
endif()

set(
  INSTALL_TARGETS_DEFAULT_ARGS
  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR} COMPONENT Devel
)

# "inverse" install dirs, to find the base location again
gammaray_inverse_dir(GAMMARAY_INVERSE_BIN_DIR "${BIN_INSTALL_DIR}")
gammaray_inverse_dir(GAMMARAY_INVERSE_PROBE_DIR "${PLUGIN_INSTALL_DIR}/${GAMMARAY_PLUGIN_VERSION}/GAMMARAY_PROBE_ABI_DUMMY")
gammaray_inverse_dir(GAMMARAY_INVERSE_LIBEXEC_DIR "${LIBEXEC_INSTALL_DIR}")

macro_log_feature(
  HAVE_QT_CONCURRENT
  "QtConcurrent"
  "Qt concurrency library"
  "included with Qt"
  FALSE
  ""
  "Required for the GammaRay launcher process list"
)

macro_log_feature(
  HAVE_QT_WIDGETS
  "Qt Widgets"
  "Qt Widgets"
  "included with Qt"
  FALSE
  ""
  "Required for the GammaRay client UI and widget-related tools"
)

macro_log_feature(
  QT_QTSCRIPTTOOLS_FOUND
  "Script engine debugger in Qt"
  "A debugger for QtScript"
  "included with Qt"
  FALSE
  ""
  "Required for the script engine debugger tool"
)

macro_log_feature(
  HAVE_QT_WEBKIT1
  "WebKit in Qt"
  "A Qt-based web browser engine"
  "included with Qt"
  FALSE
  ""
  "Required for the webinspector tool"
)

macro_log_feature(
  HAVE_QT_SVG
  "Qt SVG"
  "Qt SVG renderer and generator"
  "http://qt-project.org/"
  FALSE
  ""
  "Required for widget SVG export"
)

macro_log_feature(
  HAVE_QT_DESIGNER
  "Qt Designer Library"
  "Qt graphical widget editor"
  "http://qt-project.org/"
  FALSE
  ""
  "Required for widget .ui file export"
)

macro_log_feature(
  HAVE_QT_PRINTSUPPORT
  "Qt Print Support"
  "Qt PDF generation"
  "http://qt-project.org/"
  FALSE
  ""
  "Required for widget PDF export"
)

if(NOT Qt5Core_FOUND)
find_path(
  QT_PRIVATE_INCLUDE_DIR private/qobject_p.h
  PATHS ${QT_INCLUDES}
)
if(QT_PRIVATE_INCLUDE_DIR)
  # not enough, some of them include harfbuzz headers, so we need to find those as well
  # for now we assume a regular Qt4 source build layout, but that probably should be generalized
  find_path(
    HARFBUZZ_INCLUDE_DIR harfbuzz.h
    PATH ${QT_PRIVATE_INCLUDE_DIR}/../../src/3rdparty/harfbuzz/src
  )
endif()

if(QT_PRIVATE_INCLUDE_DIR AND HARFBUZZ_INCLUDE_DIR)
  set(HAVE_PRIVATE_QT_HEADERS TRUE)
  include_directories(${HARFBUZZ_INCLUDE_DIR})
else()
  set(HAVE_PRIVATE_QT_HEADERS FALSE)
  # needs to go before Qt includes, in case we have non-working headers with the same name there
  include_directories(BEFORE ${CMAKE_SOURCE_DIR}/3rdparty/qt)
endif()
else() # Qt 5
  find_path(QT_PRIVATE_INCLUDE_DIR private/qobject_p.h PATHS ${Qt5Core_PRIVATE_INCLUDE_DIRS})
  if(QT_PRIVATE_INCLUDE_DIR)
    set(HAVE_PRIVATE_QT_HEADERS true)
  endif()
endif()

macro_log_feature(
  HAVE_PRIVATE_QT_HEADERS
  "Qt internals"
  "Private Qt headers, necessary for painter debugging/profiling."
  "http://developer.qt.nokia.com/"
  FALSE
  ${QT_MIN_VERSION}
  "You must have a build version of Qt available. Make sure the qmake found first in your execute comes from this build version."
)

if(Qt5Core_FOUND AND Qt5Core_VERSION VERSION_LESS 5.2.2)
  # https://codereview.qt-project.org/75530
  message(STATUS "Disabling timer profiler plug-in due to a bug in Qt5 <= 5.2.1.")
  set(BUILD_TIMER_PLUGIN FALSE)
else()
  if(WIN32 OR APPLE)
    set(BUILD_TIMER_PLUGIN TRUE)
  else()
    check_library_exists(rt clock_gettime "" HAVE_CLOCK_GETTIME)
    macro_log_feature(HAVE_CLOCK_GETTIME "librt" "High resolution clock for the timer profiler plugin." "part of glibc" FALSE)
    set(BUILD_TIMER_PLUGIN ${HAVE_CLOCK_GETTIME})
  endif()
endif()

if(WIN32)
  add_definitions(-DUNICODE -D_UNICODE)
endif()

if(APPLE)
  # on the Mac support an extra install directory for application bundles
  set(
    INSTALL_TARGETS_DEFAULT_ARGS
    ${INSTALL_TARGETS_DEFAULT_ARGS}
    BUNDLE DESTINATION "/Applications/Qt4"
  )
endif()

if(UNIX AND NOT APPLE)
  set(DOC_INSTALL_DIR share/doc/gammaray/)
else()
  set(DOC_INSTALL_DIR .)
endif()

# TODO: find a nicer way for all this. ideally auto-detect the name mangling
# format, but at least guess a default based on OS + compiler.
option(
  GAMMARAY_UNKNOWN_CXX_MANGLED_NAMES
  "Enable if your compiler uses an unsupported C++ name mangling scheme"
  OFF
)
if(GAMMARAY_UNKNOWN_CXX_MANGLED_NAMES)
  add_definitions(-DGAMMARAY_UNKNOWN_CXX_MANGLED_NAMES)
endif()

include(CheckIncludeFiles)
check_include_files(stdint.h HAVE_STDINT_H)

include(GammaRayProbeABI) # this needs to be run after we know what exactly we are building

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config-gammaray-version.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config-gammaray-version.h
)

if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
  check_cxx_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wcast-qual -Wmissing-noreturn -Werror=return-type")
  if(HAVE_GCC_UNUSED_BUT_SET)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-but-set-variable")
  endif()
  if(HAVE_GCC_LOGICAL_OP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
  endif()
  if(MINGW)
    # mingw will error out on the crazy casts in probe.cpp without this
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
  else()
    # visibility attributes not supported on mingw, don't use -fvisibility option
    # see: http://stackoverflow.com/questions/7994415/mingw-fvisibility-hidden-does-not-seem-to-work
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
  endif()
endif()

# linker flags

=== client/CMakeLists.txt ===
set(gammaray_client_srcs
  main.cpp
  client.cpp
  remotemodel.cpp
  selectionmodelclient.cpp
  clientconnectionmanager.cpp
  propertycontrollerclient.cpp
  probecontrollerclient.cpp
)

qt4_add_resources(gammaray_client_srcs ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc)

add_executable(gammaray-client WIN32 ${gammaray_client_srcs})

target_link_libraries(gammaray-client
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  ${QT_QTNETWORK_LIBRARIES}
  gammaray_common
  gammaray_ui
  gammaray_ui_internal
)

if(QNXNTO)
  target_link_libraries(gammaray-client cpp)
endif()

gammaray_embed_info_plist(gammaray-client ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in)
set_target_properties(gammaray-client PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
)

install(TARGETS gammaray-client DESTINATION ${LIBEXEC_INSTALL_DIR})

=== cmake/CMakeLists.txt ===
install(FILES GammaRayMacros.cmake DESTINATION ${CMAKECONFIG_INSTALL_DIR})

=== common/CMakeLists.txt ===
#
# Shared non-UI code between probe and client
#
set(gammaray_common_srcs
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/klinkitemselectionmodel.cpp
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/kmodelindexproxymapper.cpp

  methodargument.cpp
  objectbroker.cpp
  protocol.cpp
  message.cpp
  endpoint.cpp
  paths.cpp
)

add_library(gammaray_common SHARED ${gammaray_common_srcs})
set_target_properties(gammaray_common PROPERTIES
  DEFINE_SYMBOL MAKE_GAMMARAY_COMMON_LIB
  SOVERSION ${GAMMARAY_SOVERSION}
  VERSION ${GAMMARAY_SOVERSION}
  OUTPUT_NAME gammaray_common-${GAMMARAY_PROBE_ABI}
)

if(Qt5Core_FOUND)
  target_link_libraries(gammaray_common Qt5::Core Qt5::Network)
else()
  target_link_libraries(gammaray_common
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTNETWORK_LIBRARIES}
  )
endif()

install(TARGETS gammaray_common EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

set(gammaray_common_internal_srcs
  pluginmanager.cpp
  proxyfactorybase.cpp
  propertycontrollerinterface.cpp
  probecontrollerinterface.cpp
  modelinspectorinterface.cpp
  resourcebrowserinterface.cpp
  networkselectionmodel.cpp
  streamoperators.cpp
)

if(NOT WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif()

add_library(gammaray_common_internal STATIC ${gammaray_common_internal_srcs})

target_link_libraries(gammaray_common_internal gammaray_common)
if(Qt5Core_FOUND)
  target_link_libraries(gammaray_common_internal Qt5::Gui Qt5::Network)
else()
  target_link_libraries(gammaray_common_internal
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTNETWORK_LIBRARIES}
  )
endif()

gammaray_install_headers(
  gammaray_common_export.h
  endpoint.h
  enums.h
  metatypedeclarations.h
  modelroles.h
  objectbroker.h
  objectmodel.h
  propertycontrollerinterface.h
  protocol.h
)

=== core/CMakeLists.txt ===
set(gammaray_srcs
  ${CMAKE_SOURCE_DIR}/3rdparty/qt/resourcemodel.cpp

  metaobject.cpp
  metaobjecttreemodel.cpp
  metaobjectrepository.cpp
  metaproperty.cpp
  metapropertymodel.cpp
  probe.cpp
  probesettings.cpp
  probecontroller.cpp
#  proxydetacher.cpp
  objectlistmodel.cpp
  objectpropertymodel.cpp
  objectdynamicpropertymodel.cpp
  objectstaticpropertymodel.cpp
  objectclassinfomodel.cpp
  objectmethodmodel.cpp
  objectenummodel.cpp
  objecttreemodel.cpp
  connectionmodel.cpp
  connectionfilterproxymodel.cpp
  methodargumentmodel.cpp
  multisignalmapper.cpp
  toolmodel.cpp
  toolpluginmodel.cpp
  toolpluginerrormodel.cpp
  propertycontroller.cpp
  proxytoolfactory.cpp
  util.cpp
  varianthandler.cpp

  tools/modelinspector/modeltester.cpp
  tools/modelinspector/modelmodel.cpp
  tools/modelinspector/modelcellmodel.cpp
  tools/metatypebrowser/metatypesmodel.cpp
  tools/localeinspector/localemodel.cpp
  tools/localeinspector/localedataaccessor.cpp
  tools/localeinspector/localeaccessormodel.cpp
  tools/textdocumentinspector/textdocumentmodel.cpp
  tools/textdocumentinspector/textdocumentformatmodel.cpp
  tools/messagehandler/messagehandler.cpp
  tools/messagehandler/messagehandlerinterface.cpp
  tools/messagehandler/messagemodel.cpp
  tools/connectioninspector/connectioninspector.cpp
  tools/localeinspector/localeinspector.cpp
  tools/metaobjectbrowser/metaobjectbrowser.cpp
  tools/metatypebrowser/metatypebrowser.cpp
  tools/modelinspector/modelinspector.cpp
  tools/objectinspector/objectinspector.cpp
  tools/resourcebrowser/resourcebrowser.cpp
  tools/resourcebrowser/resourcefiltermodel.cpp
  tools/textdocumentinspector/textdocumentinspector.cpp

  remote/server.cpp
  remote/remotemodelserver.cpp
  remote/selectionmodelserver.cpp
)

if(Qt5Core_FOUND)
  set(gammaray_srcs
    ${gammaray_srcs}
    tools/mimetypes/mimetypes.cpp
    tools/mimetypes/mimetypesmodel.cpp
    tools/standardpaths/standardpaths.cpp
    tools/standardpaths/standardpathsmodel.cpp
  )
endif()

if(NOT WIN32)
  set(gammaray_srcs ${gammaray_srcs} tools/messagehandler/backtrace_unix.cpp)
elseif(MINGW)
  set(gammaray_srcs ${gammaray_srcs} tools/messagehandler/backtrace_dummy.cpp)
else()
  set(gammaray_srcs ${gammaray_srcs}
    tools/messagehandler/backtrace_win.cpp
    tools/messagehandler/StackWalker.cpp)
endif()

qt4_wrap_cpp(gammaray_srcs tools/modelinspector/modeltest.h)
qt4_add_resources(gammaray_srcs ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc)

add_definitions(-DMAKE_GAMMARAY_CORE_LIB)

# core lib
add_library(gammaray_core SHARED
  ${gammaray_srcs}
)

target_link_libraries(gammaray_core
  gammaray_common
  gammaray_common_internal
)
set_target_properties(gammaray_core PROPERTIES
  SOVERSION ${GAMMARAY_SOVERSION}
  VERSION ${GAMMARAY_SOVERSION}
  OUTPUT_NAME gammaray_core-${GAMMARAY_PROBE_ABI}
)

if(Qt5Core_FOUND)
  target_link_libraries(gammaray_core Qt5::Gui)
else()
  target_link_libraries(gammaray_core
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTNETWORK_LIBRARIES}
  )
endif()

target_link_libraries(gammaray_core LINK_INTERFACE_LIBRARIES gammaray_common ${QT_QTCORE_LIBRARIES})
install(TARGETS gammaray_core EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

gammaray_install_headers(
  gammaray_core_export.h
  metaobject.h
  metaobjectrepository.h
  metaproperty.h
  objectmodelbase.h
  objecttypefilterproxymodel.h
  probeinterface.h
  propertycontroller.h
  singlecolumnobjectproxymodel.h
  toolfactory.h
  util.h
  varianthandler.h
)

=== hooking/CMakeLists.txt ===
set(gammaray_probe_srcs
  probecreator.cpp
  hooks.cpp
)

if(WIN32 OR APPLE)
  set(gammaray_probe_srcs
    ${gammaray_probe_srcs}
    abstractfunctionoverwriter.cpp
    functionoverwriterfactory.cpp
    winfunctionoverwriter.cpp
    unixfunctionoverwriter.cpp
  )
endif()

# probe lib
if(APPLE) # DYLD_INSERT_LIBRARIES only works with real shared libraries, not modules
  add_library(gammaray_probe SHARED ${gammaray_probe_srcs})
else()
  add_library(gammaray_probe MODULE ${gammaray_probe_srcs})
endif()
target_link_libraries(gammaray_probe
  gammaray_core
)

if(NOT WIN32 AND NOT QNXNTO)
  target_link_libraries(gammaray_probe dl)
endif()

set_target_properties(gammaray_probe PROPERTIES
  PREFIX ""
  LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${PLUGIN_INSTALL_DIR}/${GAMMARAY_PLUGIN_VERSION}/${GAMMARAY_PROBE_ABI}"
)
install(TARGETS gammaray_probe DESTINATION ${PLUGIN_INSTALL_DIR}/${GAMMARAY_PLUGIN_VERSION}/${GAMMARAY_PROBE_ABI}/)

=== inprocessui/CMakeLists.txt ===
add_library(gammaray_inprocessui MODULE main.cpp)
target_link_libraries(gammaray_inprocessui gammaray_core gammaray_ui_internal)
set_target_properties(gammaray_inprocessui PROPERTIES
  PREFIX ""
  LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${PLUGIN_INSTALL_DIR}/${GAMMARAY_PLUGIN_VERSION}/${GAMMARAY_PROBE_ABI}"
)
install(TARGETS gammaray_inprocessui DESTINATION ${PLUGIN_INSTALL_DIR}/${GAMMARAY_PLUGIN_VERSION}/${GAMMARAY_PROBE_ABI})

=== launcher/CMakeLists.txt ===
add_subdirectory(injector)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
)

# shared launcher code
set(gammaray_launcher_shared_srcs
  injector/abstractinjector.cpp
  injector/processinjector.cpp
  injector/injectorfactory.cpp
  injector/preloadinjector.cpp
  injector/styleinjector.cpp
  injector/windllinjector.cpp
  injector/interactiveprocess.cpp
  injector/preloadcheck.cpp

  probefinder.cpp
  launchoptions.cpp
  clientlauncher.cpp
  launcherfinder.cpp
)
if(NOT WIN32)
  list(APPEND gammaray_launcher_shared_srcs
    injector/debuggerinjector.cpp
    injector/gdbinjector.cpp
    injector/lldbinjector.cpp
  )
endif()
add_library(gammaray_launcher_shared STATIC ${gammaray_launcher_shared_srcs})
target_link_libraries(gammaray_launcher_shared ${QT_QTCORE_LIBRARIES} gammaray_common)
if(HAVE_QT_WIDGETS)
  target_link_libraries(gammaray_launcher_shared ${QT_QTGUI_LIBRARIES})
endif()

# command line launcher
set(gammaray_runner_srcs
  launcher.cpp
  main.cpp
)

add_executable(gammaray ${gammaray_runner_srcs})

target_link_libraries(gammaray gammaray_launcher_shared)

if(QNXNTO)
  target_link_libraries(gammaray cpp)
endif()

if(UNIX AND NOT APPLE AND NOT QNXNTO)
  target_link_libraries(gammaray dl) # for preload check
endif()

gammaray_embed_info_plist(gammaray ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in)

install(TARGETS gammaray ${INSTALL_TARGETS_DEFAULT_ARGS})

# UI launcher
if(HAVE_QT_CONCURRENT AND HAVE_QT_WIDGETS)
  add_subdirectory(ui)
endif()

=== plugins/CMakeLists.txt ===
add_subdirectory(codecbrowser)
add_subdirectory(fontbrowser)
add_subdirectory(kjobtracker)
add_subdirectory(objectvisualizer)
add_subdirectory(selectionmodelinspector)
add_subdirectory(statemachineviewer)
add_subdirectory(timertop)
add_subdirectory(webinspector)

if(Qt5Widgets_FOUND OR QT_QTGUI_FOUND)
  add_subdirectory(actioninspector)
  add_subdirectory(widgetinspector)
  add_subdirectory(sceneinspector)
  add_subdirectory(styleinspector)
endif()

if(QT_QTSCRIPTTOOLS_FOUND OR Qt5ScriptTools_FOUND)
  add_subdirectory(scriptenginedebugger)
endif()

=== tests/CMakeLists.txt ===
### BENCH SUITE

if(Qt5Widgets_FOUND OR QT_QTGUI_FOUND)
  add_executable(benchsuite benchsuite.cpp)

  target_link_libraries(benchsuite
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTTEST_LIBRARIES}
    gammaray_common
    gammaray_core
  )

  if(QNXNTO)
    target_link_libraries(benchsuite cpp)
  endif()

### CONNECTIONTEST

  add_executable(connectiontest test_connections.cpp)

  target_link_libraries(connectiontest
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTTEST_LIBRARIES}
  )

  if(QNXNTO)
    target_link_libraries(connectiontest cpp)
  endif()
endif()

add_executable(attachhelper attachhelper.cpp)

target_link_libraries(attachhelper ${QT_QTCORE_LIBRARIES})

if(QNXNTO)
  target_link_libraries(attachhelper cpp)
endif()

if(UNIX AND NOT APPLE)
  add_test(connectiontest-preload
    ${PROJECT_BINARY_DIR}/bin/gammaray --inprocess -unittest -i preload
    ${PROJECT_BINARY_DIR}/bin/connectiontest
  )
  add_test(connectiontest-style
    ${PROJECT_BINARY_DIR}/bin/gammaray --inprocess -unittest -i style
    ${PROJECT_BINARY_DIR}/bin/connectiontest
  )

  set(RUN_FILTER_TESTS OFF
    CACHE BOOL "Run filter tests which fail due to a bug in QSortFilterProxyModel"
  )
  if(RUN_FILTER_TESTS)
    add_test(connectiontest-preload-filter
      ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -filtertest -i preload
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
    add_test(connectiontest-preload-filter-modeltest
      ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -modeltest -filtertest -i preload
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
    add_test(connectiontest-style-filter
      ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -filtertest -i style
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
  endif()

  find_program(GDB_EXECUTABLE gdb)
  if(GDB_EXECUTABLE)
    add_test(connectiontest-gdb
      ${PROJECT_BINARY_DIR}/bin/gammaray --inprocess -unittest -i gdb
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
    add_test(attachtest-gdb
      ${PROJECT_BINARY_DIR}/bin/attachhelper ${PROJECT_BINARY_DIR}/bin/gammaray gdb
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
    if(RUN_FILTER_TESTS)
      add_test(connectiontest-gdb-filter
        ${PROJECT_BINARY_DIR}/bin/gammaray --inprocess -unittest -filtertest -i gdb
        ${PROJECT_BINARY_DIR}/bin/connectiontest
      )
    endif()
  endif()
endif()

add_subdirectory(manual)

=== ui/CMakeLists.txt ===
#
# Shared code between in-process and out-of-process UI
#
set(gammaray_ui_srcs
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/krecursivefilterproxymodel.cpp
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/kfilterproxysearchline.cpp

  ${CMAKE_SOURCE_DIR}/3rdparty/other/modelutils.cpp

  palettemodel.cpp
  methodinvocationdialog.cpp
  propertywidget.cpp
  deferredresizemodesetter.cpp
  deferredtreeviewconfiguration.cpp
  splashscreen.cpp

  propertyeditor/propertycoloreditor.cpp
  propertyeditor/propertydoublepaireditor.cpp
  propertyeditor/propertyeditorfactory.cpp
  propertyeditor/propertyextendededitor.cpp
  propertyeditor/propertyfonteditor.cpp
  propertyeditor/propertyintpaireditor.cpp
  propertyeditor/propertypaletteeditor.cpp
  propertyeditor/palettedialog.cpp
  propertyeditor/propertyeditordelegate.cpp
)

if(NOT Qt5Core_VERSION VERSION_LESS 5.2.0)
  list(APPEND gammaray_ui_srcs
    variantcontainermodel.cpp
  )
endif()

qt4_wrap_ui(gammaray_ui_srcs
  methodinvocationdialog.ui
  propertywidget.ui

  propertyeditor/propertydoublepaireditor.ui
  propertyeditor/propertyextendededitor.ui
  propertyeditor/propertyintpaireditor.ui
  propertyeditor/palettedialog.ui
)

add_library(gammaray_ui SHARED ${gammaray_ui_srcs})
set_target_properties(gammaray_ui PROPERTIES
  DEFINE_SYMBOL MAKE_GAMMARAY_UI_LIB
  SOVERSION ${GAMMARAY_SOVERSION}
  VERSION ${GAMMARAY_SOVERSION}
  OUTPUT_NAME gammaray_ui-${GAMMARAY_PROBE_ABI}
)

target_link_libraries(gammaray_ui
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  gammaray_common_internal
)

target_link_libraries(gammaray_ui LINK_INTERFACE_LIBRARIES
  gammaray_common
  ${QT_QTGUI_LIBRARIES}
)

install(TARGETS gammaray_ui EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

set(gammaray_ui_internal_srcs
  sidepane.cpp
  aboutpluginsdialog.cpp
  mainwindow.cpp
  aboutdialog.cpp
  proxytooluifactory.cpp
  clienttoolmodel.cpp

  tools/connectioninspector/connectioninspectorwidget.cpp
  tools/localeinspector/localeinspectorwidget.cpp
  tools/messagehandler/messagehandlerwidget.cpp
  tools/messagehandler/messagehandlerclient.cpp
  ../core/tools/messagehandler/messagehandlerinterface.cpp
  tools/metaobjectbrowser/metaobjectbrowserwidget.cpp
  tools/metatypebrowser/metatypebrowserwidget.cpp
  tools/mimetypes/mimetypeswidget.cpp
  tools/modelinspector/modelinspectorwidget.cpp
  tools/modelinspector/modelinspectorclient.cpp
  tools/objectinspector/objectinspectorwidget.cpp
  tools/resourcebrowser/clientresourcemodel.cpp
  tools/resourcebrowser/resourcebrowserwidget.cpp
  tools/resourcebrowser/resourcebrowserclient.cpp
  tools/standardpaths/standardpathswidget.cpp
  tools/textdocumentinspector/textdocumentinspectorwidget.cpp
  tools/textdocumentinspector/textdocumentcontentview.cpp
)

qt4_wrap_ui(gammaray_ui_internal_srcs
  mainwindow.ui
  aboutdialog.ui

  tools/connectioninspector/connectioninspectorwidget.ui
  tools/localeinspector/localeinspectorwidget.ui
  tools/messagehandler/messagehandlerwidget.ui
  tools/metatypebrowser/metatypebrowserwidget.ui
  tools/mimetypes/mimetypeswidget.ui
  tools/modelinspector/modelinspectorwidget.ui
  tools/objectinspector/objectinspectorwidget.ui
  tools/resourcebrowser/resourcebrowserwidget.ui
  tools/standardpaths/standardpathswidget.ui
  tools/textdocumentinspector/textdocumentinspectorwidget.ui
)

if(NOT WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif()

add_library(gammaray_ui_internal STATIC ${gammaray_ui_internal_srcs})

target_link_libraries(gammaray_ui_internal
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  gammaray_common_internal
  gammaray_ui
)

gammaray_install_headers(
  gammaray_ui_export.h
  deferredresizemodesetter.h
  deferredtreeviewconfiguration.h
  palettemodel.h
  propertywidget.h
  tooluifactory.h
)

=== launcher/injector/CMakeLists.txt ===
if(Qt5Widgets_FOUND OR QT_QTGUI_FOUND)
  set(gammaray_injector_style_srcs injectorstyleplugin.cpp)

  add_library(gammaray_injector_style MODULE ${gammaray_injector_style_srcs})

  target_link_libraries(gammaray_injector_style
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
  )

  set_target_properties(gammaray_injector_style
    PROPERTIES PREFIX ""
    LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${PLUGIN_INSTALL_DIR}/${GAMMARAY_PLUGIN_VERSION}/${GAMMARAY_PROBE_ABI}/styles
  )

  install(
    TARGETS gammaray_injector_style
    DESTINATION ${PLUGIN_INSTALL_DIR}/${GAMMARAY_PLUGIN_VERSION}/${GAMMARAY_PROBE_ABI}/styles
  )
endif()

=== debian/changelog ===
gammaray (2.0.1-1ubuntu1) trusty; urgency=medium

  * Fix build failure with GraphViz >= 2.36.0.
    - Add graphviz-2.36.0.patch, cherry-picked from upstream.

 -- Felix Geyer <debfx@ubuntu.com>  Tue, 18 Mar 2014 17:16:13 +0100

gammaray (2.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Refreshed d/patches/use-empty-rpath.patch.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Wed, 05 Mar 2014 19:28:40 +0100

gammaray (2.0.0-1) unstable; urgency=low

  * New upstream release.
  * Refreshed d/patches/use-empty-rpath.patch.
  * Removed no longer needed patches:
    - widget-export-actions-location.patch
    - harfbuzz-search-path.patch
    - find-widget-export-actions-when-attaching.patch
    - gammaray-probe-versioned-soname.patch.
  * Use xz for orig tarball compression.
  * Bump Standards-Version to 3.9.5.
  * Enable build of Qt5 GUI and Qt5 + Qt4 probe libraries.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Tue, 21 Jan 2014 22:03:14 +0100

gammaray (1.3.0-1) experimental; urgency=low

  * New upstream release.
  * Add dependency on VTK 5.10 and enable object visualizer plugin.
  * Don't set RPATH in binaries; prevents binary-or-shlib-defines-rpath
    lintian error.
  * Refreshed d/patches/widget-export-actions-location.patch and
    d/patches/gammaray-probe-versioned-soname.patch.
  * Enable KJob tracker plugin.
  * Updated d/copyright.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Mon, 04 Feb 2013 22:54:36 +0100

=== debian/control ===
Source: gammaray
Priority: optional
Section: devel
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Jakub Adam <jakub.adam@ktknet.cz>
Build-Depends: debhelper (>= 9),
               cmake,
               kdelibs5-dev,
               qtbase5-private-dev,
               qtscript5-dev,
               qttools5-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               qtdeclarative5-dev,
               libqt4-dev,
               libqt4-private-dev,
               libqtwebkit-dev,
               libgraphviz-dev,
               gdb,
               xauth,
               xvfb
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/gammaray.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/kde-extras/gammaray.git
Homepage: http://www.kdab.com/gammaray

Package: gammaray
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: gammaray-probe-qt4,
            gdb
Description: Tool for examining the internals of Qt application
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.

Package: gammaray-probe-qt4
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: gammaray (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: GammaRay support for inspecting Qt4 applications
 This package contains GammaRay probe libraries that have to be loaded
 into the application being inspected in order to allow GammaRay to
 examine its internals. The gammaray package already includes the probe
 binaries compiled for Qt5. Install this package if you want to use
 GammaRay with Qt4 applications.

#Package: gammaray-plugin-objectvisualizer
#Architecture: any
#Depends: gammaray (= ${binary:Version}),
#         ${shlibs:Depends},
#         ${misc:Depends}
#Description: QObject hierarchy visualization plugin for GammaRay
# This plugin can visualize parent-child relationships of QObjects in a
# form of planar or 3D acyclic graph. Multiple graph layout algorihtms
# are available.
# .
# Also, for use with 3D glasses, various types of stereoscopic rendering
# are supported.

Package: gammaray-plugin-kjobtracker
Architecture: any
Depends: gammaray (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: KJob tracker plugin for GammaRay
 This plugin can be used to monitor KJob instances within a KDE-based
 application.

Package: gammaray-dev
Architecture: any
Section: libdevel
Depends: gammaray (= ${binary:Version}),
         ${misc:Depends}
Description: GammaRay plugin development files
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains header files used for building 3rd party GammaRay
 plugins.

Package: gammaray-dbg
Architecture: any
Section: debug
Priority: extra
Depends: gammaray (= ${binary:Version}),
         ${misc:Depends}
Description: debugging symbols for gammaray
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains the debugging symbols for gammaray.

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_installdocs override_dh_strip override_dh_clean

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

%:
	dh $@ --parallel

override_dh_auto_configure:
	# Move away bundled Qt private headers so that system versions are used
	if [ -d 3rdparty/qt/private ]; then \
		mv 3rdparty/qt/private 3rdparty/qt/private.dont.use; \
	fi

	dh_auto_configure -B obj-qt5
	dh_auto_configure -B obj-qt4 -- -DGAMMARAY_ENFORCE_QT4_BUILD=ON -DGAMMARAY_PROBE_ONLY_BUILD=ON

override_dh_auto_build:
	dh_auto_build -B obj-qt5 -O--parallel
	dh_auto_build -B obj-qt4 -O--parallel

override_dh_auto_test:
	xvfb-run dh_auto_test

override_dh_auto_install:
	dh_auto_install -B obj-qt5
	dh_auto_install -B obj-qt4
	rm -f debian/tmp/usr/share/doc/gammaray/License.txt

override_dh_installdocs:
	dh_installdocs --link-doc=gammaray

override_dh_strip:
	dh_strip --dbg-package=gammaray-dbg

override_dh_clean:
	dh_clean

	# Put back bundled Qt private headers to restore sources into original state
	if [ -d 3rdparty/qt/private.dont.use ]; then \
		mv 3rdparty/qt/private.dont.use 3rdparty/qt/private; \
	fi
